diff a/src/hotspot/share/prims/jvm.cpp b/src/hotspot/share/prims/jvm.cpp
--- a/src/hotspot/share/prims/jvm.cpp
+++ b/src/hotspot/share/prims/jvm.cpp
@@ -3829,11 +3857,11 @@
 #endif
 JVM_END
 
 // If notifications are disabled then just update the VTMS transition bit and return.
 // Otherwise, the bit is updated in the given jvmtiVTMSTransitionDisabler function call.
-JVM_ENTRY(void, JVM_VirtualThreadMount(JNIEnv* env, jobject vthread, jboolean hide))
+JVM_ENTRY_PROF(void, JVM_VirtualThreadMount, JVM_VirtualThreadMount(JNIEnv* env, jobject vthread, jboolean hide))
 #if INCLUDE_JVMTI
   if (!DoJVMTIVirtualThreadTransitions) {
     assert(!JvmtiExport::can_support_virtual_threads(), "sanity check");
     return;
   }
@@ -3846,11 +3874,11 @@
 #endif
 JVM_END
 
 // If notifications are disabled then just update the VTMS transition bit and return.
 // Otherwise, the bit is updated in the given jvmtiVTMSTransitionDisabler function call below.
-JVM_ENTRY(void, JVM_VirtualThreadUnmount(JNIEnv* env, jobject vthread, jboolean hide))
+JVM_ENTRY_PROF(void, JVM_VirtualThreadUnmount, JVM_VirtualThreadUnmount(JNIEnv* env, jobject vthread, jboolean hide))
 #if INCLUDE_JVMTI
   if (!DoJVMTIVirtualThreadTransitions) {
     assert(!JvmtiExport::can_support_virtual_threads(), "sanity check");
     return;
   }
@@ -3913,11 +3941,11 @@
 /*
  * Return the current class's class file version.  The low order 16 bits of the
  * returned jint contain the class's major version.  The high order 16 bits
  * contain the class's minor version.
  */
-JVM_ENTRY(jint, JVM_GetClassFileVersion(JNIEnv* env, jclass current))
+JVM_ENTRY_PROF(jint, JVM_GetClassFileVersion, JVM_GetClassFileVersion(JNIEnv* env, jclass current))
   oop mirror = JNIHandles::resolve_non_null(current);
   if (java_lang_Class::is_primitive(mirror)) {
     // return latest major version and minor version of 0.
     return JVM_CLASSFILE_MAJOR_VERSION;
   }
@@ -3932,15 +3960,246 @@
 /*
  * Ensure that code doing a stackwalk and using javaVFrame::locals() to
  * get the value will see a materialized value and not a scalar-replaced
  * null value.
  */
-JVM_ENTRY(void, JVM_EnsureMaterializedForStackWalk_func(JNIEnv* env, jobject vthread, jobject value))
+JVM_ENTRY_PROF(void, JVM_EnsureMaterializedForStackWalk_func, JVM_EnsureMaterializedForStackWalk_func(JNIEnv* env, jobject vthread, jobject value))
   JVM_EnsureMaterializedForStackWalk(env, value);
 JVM_END
 
 /*
  * Return JNI_TRUE if warnings are printed when agents are dynamically loaded.
  */
-JVM_LEAF(jboolean, JVM_PrintWarningAtDynamicAgentLoad(void))
+JVM_LEAF_PROF(jboolean, JVM_PrintWarningAtDynamicAgentLoad, JVM_PrintWarningAtDynamicAgentLoad(void))
   return (EnableDynamicAgentLoading && !FLAG_IS_CMDLINE(EnableDynamicAgentLoading)) ? JNI_TRUE : JNI_FALSE;
 JVM_END
+
+#define DO_COUNTERS(macro) \
+  macro(JVM_CurrentTimeMillis) \
+  macro(JVM_NanoTime) \
+  macro(JVM_GetNanoTimeAdjustment) \
+  macro(JVM_ArrayCopy) \
+  macro(JVM_GetProperties) \
+  macro(JVM_GetTemporaryDirectory) \
+  macro(JVM_BeforeHalt) \
+  macro(JVM_Halt) \
+  macro(JVM_GC) \
+  macro(JVM_MaxObjectInspectionAge) \
+  macro(JVM_TotalMemory) \
+  macro(JVM_FreeMemory) \
+  macro(JVM_MaxMemory) \
+  macro(JVM_ActiveProcessorCount) \
+  macro(JVM_IsUseContainerSupport) \
+  macro(JVM_FillInStackTrace) \
+  macro(JVM_GetExtendedNPEMessage) \
+  macro(JVM_InitStackTraceElementArray) \
+  macro(JVM_InitStackTraceElement) \
+  macro(JVM_ExpandStackFrameInfo) \
+  macro(JVM_CallStackWalk) \
+  macro(JVM_MoreStackWalk) \
+  macro(JVM_SetStackWalkContinuation) \
+  macro(JVM_IHashCode) \
+  macro(JVM_MonitorWait) \
+  macro(JVM_MonitorNotify) \
+  macro(JVM_MonitorNotifyAll) \
+  macro(JVM_Clone) \
+  macro(JVM_ReportFinalizationComplete) \
+  macro(JVM_IsFinalizationEnabled) \
+  macro(JVM_RegisterContinuationMethods) \
+  macro(JVM_NativePath) \
+  macro(JVM_GetCallerClass) \
+  macro(JVM_FindPrimitiveClass) \
+  macro(JVM_FindClassFromBootLoader) \
+  macro(JVM_FindClassFromCaller) \
+  macro(JVM_FindClassFromClass) \
+  macro(JVM_DefineClass) \
+  macro(JVM_LookupDefineClass) \
+  macro(JVM_DefineClassWithSource) \
+  macro(JVM_FindLoadedClass) \
+  macro(JVM_DefineModule) \
+  macro(JVM_SetBootLoaderUnnamedModule) \
+  macro(JVM_AddModuleExports) \
+  macro(JVM_AddModuleExportsToAllUnnamed) \
+  macro(JVM_AddModuleExportsToAll) \
+  macro(JVM_AddReadsModule) \
+  macro(JVM_DefineArchivedModules) \
+  macro(JVM_InitClassName) \
+  macro(JVM_GetClassInterfaces) \
+  macro(JVM_IsInterface) \
+  macro(JVM_IsHiddenClass) \
+  macro(JVM_GetProtectionDomain) \
+  macro(JVM_FindScopedValueBindings) \
+  macro(JVM_IsArrayClass) \
+  macro(JVM_IsPrimitiveClass) \
+  macro(JVM_GetClassModifiers) \
+  macro(JVM_GetDeclaredClasses) \
+  macro(JVM_GetDeclaringClass) \
+  macro(JVM_GetSimpleBinaryName) \
+  macro(JVM_GetClassSignature) \
+  macro(JVM_GetClassAnnotations) \
+  macro(JVM_GetClassTypeAnnotations) \
+  macro(JVM_GetMethodTypeAnnotations) \
+  macro(JVM_GetFieldTypeAnnotations) \
+  macro(JVM_GetMethodParameters) \
+  macro(JVM_GetClassDeclaredFields) \
+  macro(JVM_IsRecord) \
+  macro(JVM_GetRecordComponents) \
+  macro(JVM_GetClassDeclaredMethods) \
+  macro(JVM_GetClassDeclaredConstructors) \
+  macro(JVM_GetClassAccessFlags) \
+  macro(JVM_AreNestMates) \
+  macro(JVM_GetNestHost) \
+  macro(JVM_GetNestMembers) \
+  macro(JVM_GetPermittedSubclasses) \
+  macro(JVM_GetClassConstantPool) \
+  macro(JVM_ConstantPoolGetSize) \
+  macro(JVM_ConstantPoolGetClassAt) \
+  macro(JVM_ConstantPoolGetClassAtIfLoaded) \
+  macro(JVM_ConstantPoolGetMethodAt) \
+  macro(JVM_ConstantPoolGetMethodAtIfLoaded) \
+  macro(JVM_ConstantPoolGetFieldAt) \
+  macro(JVM_ConstantPoolGetFieldAtIfLoaded) \
+  macro(JVM_ConstantPoolGetMemberRefInfoAt) \
+  macro(JVM_ConstantPoolGetClassRefIndexAt) \
+  macro(JVM_ConstantPoolGetNameAndTypeRefIndexAt) \
+  macro(JVM_ConstantPoolGetNameAndTypeRefInfoAt) \
+  macro(JVM_ConstantPoolGetIntAt) \
+  macro(JVM_ConstantPoolGetLongAt) \
+  macro(JVM_ConstantPoolGetFloatAt) \
+  macro(JVM_ConstantPoolGetDoubleAt) \
+  macro(JVM_ConstantPoolGetStringAt) \
+  macro(JVM_ConstantPoolGetUTF8At) \
+  macro(JVM_ConstantPoolGetTagAt) \
+  macro(JVM_DesiredAssertionStatus) \
+  macro(JVM_AssertionStatusDirectives) \
+  macro(JVM_GetClassNameUTF) \
+  macro(JVM_GetClassCPTypes) \
+  macro(JVM_GetClassCPEntriesCount) \
+  macro(JVM_GetClassFieldsCount) \
+  macro(JVM_GetClassMethodsCount) \
+  macro(JVM_GetMethodIxExceptionIndexes) \
+  macro(JVM_GetMethodIxExceptionsCount) \
+  macro(JVM_GetMethodIxByteCode) \
+  macro(JVM_GetMethodIxByteCodeLength) \
+  macro(JVM_GetMethodIxExceptionTableEntry) \
+  macro(JVM_GetMethodIxExceptionTableLength) \
+  macro(JVM_GetMethodIxModifiers) \
+  macro(JVM_GetFieldIxModifiers) \
+  macro(JVM_GetMethodIxLocalsCount) \
+  macro(JVM_GetMethodIxArgsSize) \
+  macro(JVM_GetMethodIxMaxStack) \
+  macro(JVM_IsConstructorIx) \
+  macro(JVM_IsVMGeneratedMethodIx) \
+  macro(JVM_GetMethodIxNameUTF) \
+  macro(JVM_GetMethodIxSignatureUTF) \
+  macro(JVM_GetCPFieldNameUTF) \
+  macro(JVM_GetCPMethodNameUTF) \
+  macro(JVM_GetCPMethodSignatureUTF) \
+  macro(JVM_GetCPFieldSignatureUTF) \
+  macro(JVM_GetCPClassNameUTF) \
+  macro(JVM_GetCPFieldClassNameUTF) \
+  macro(JVM_GetCPMethodClassNameUTF) \
+  macro(JVM_GetCPFieldModifiers) \
+  macro(JVM_GetCPMethodModifiers) \
+  macro(JVM_ReleaseUTF) \
+  macro(JVM_IsSameClassPackage) \
+  macro(JVM_StartThread) \
+  macro(JVM_SetThreadPriority) \
+  macro(JVM_Yield) \
+  macro(JVM_SleepNanos) \
+  macro(JVM_CurrentCarrierThread) \
+  macro(JVM_CurrentThread) \
+  macro(JVM_SetCurrentThread) \
+  macro(JVM_GetNextThreadIdOffset) \
+  macro(JVM_Interrupt) \
+  macro(JVM_HoldsLock) \
+  macro(JVM_GetStackTrace) \
+  macro(JVM_SetNativeThreadName) \
+  macro(JVM_ScopedValueCache) \
+  macro(JVM_SetScopedValueCache) \
+  macro(JVM_GetClassContext) \
+  macro(JVM_GetSystemPackage) \
+  macro(JVM_GetSystemPackages) \
+  macro(JVM_GetAndClearReferencePendingList) \
+  macro(JVM_HasReferencePendingList) \
+  macro(JVM_WaitForReferencePendingList) \
+  macro(JVM_ReferenceRefersTo) \
+  macro(JVM_ReferenceClear) \
+  macro(JVM_PhantomReferenceRefersTo) \
+  macro(JVM_LatestUserDefinedLoader) \
+  macro(JVM_GetArrayLength) \
+  macro(JVM_GetArrayElement) \
+  macro(JVM_GetPrimitiveArrayElement) \
+  macro(JVM_SetArrayElement) \
+  macro(JVM_SetPrimitiveArrayElement) \
+  macro(JVM_NewArray) \
+  macro(JVM_NewMultiArray) \
+  macro(JVM_LoadZipLibrary) \
+  macro(JVM_LoadLibrary) \
+  macro(JVM_UnloadLibrary) \
+  macro(JVM_FindLibraryEntry) \
+  macro(JVM_IsSupportedJNIVersion) \
+  macro(JVM_IsPreviewEnabled) \
+  macro(JVM_IsContinuationsSupported) \
+  macro(JVM_IsForeignLinkerSupported) \
+  macro(JVM_InternString) \
+  macro(JVM_InvokeMethod) \
+  macro(JVM_NewInstanceFromConstructor) \
+  macro(JVM_InitializeFromArchive) \
+  macro(JVM_RegisterLambdaProxyClassForArchiving) \
+  macro(JVM_LookupLambdaProxyClassFromArchive) \
+  macro(JVM_GetRandomSeedForDumping) \
+  macro(JVM_LogLambdaFormInvoker) \
+  macro(JVM_LogDynamicProxy) \
+  macro(JVM_DumpClassListToFile) \
+  macro(JVM_DumpDynamicArchive) \
+  macro(JVM_GetAllThreads) \
+  macro(JVM_DumpThreads) \
+  macro(JVM_GetManagement) \
+  macro(JVM_InitAgentProperties) \
+  macro(JVM_GetEnclosingMethodInfo) \
+  macro(JVM_GetVmArguments) \
+  macro(JVM_FindSignal) \
+  macro(JVM_VirtualThreadStart) \
+  macro(JVM_VirtualThreadEnd) \
+  macro(JVM_VirtualThreadMount) \
+  macro(JVM_VirtualThreadUnmount) \
+  macro(JVM_GetClassFileVersion) \
+  macro(JVM_EnsureMaterializedForStackWalk_func) \
+  macro(JVM_PrintWarningAtDynamicAgentLoad)
+
+#define INIT_COUNTER(name) \
+    NEWPERFTICKCOUNTERS(_perf_##name##_timer, SUN_RT, #name); \
+    NEWPERFEVENTCOUNTER(_perf_##name##_count, SUN_RT, #name "_count"); \
+
+void perf_jvm_init() {
+  if (ProfileVMCalls && UsePerfData) {
+    EXCEPTION_MARK;
+
+    DO_COUNTERS(INIT_COUNTER)
+
+    if (HAS_PENDING_EXCEPTION) {
+      vm_exit_during_initialization("jvm_perf_init failed unexpectedly");
+    }
+  }
+}
+
+#undef INIT_COUNTER
+
+#define PRINT_COUNTER(name) {\
+  jlong count = _perf_##name##_count->get_value(); \
+  if (count > 0) { \
+    st->print_cr("  %-40s = " JLONG_FORMAT_W(6) "us (elapsed) " JLONG_FORMAT_W(6) "us (thread) (" JLONG_FORMAT_W(5) " events)", \
+                 #name,                                                   \
+                 _perf_##name##_timer->elapsed_counter_value_us(),        \
+                 _perf_##name##_timer->thread_counter_value_us(), count); \
+  }}
+
+void perf_jvm_print_on(outputStream* st) {
+  if (ProfileVMCalls && UsePerfData) {
+    DO_COUNTERS(PRINT_COUNTER)
+  } else {
+    st->print_cr("  JVM:  no info (%s is disabled)", (UsePerfData ? "ProfileVMCalls" : "UsePerfData"));
+  }
+}
+
+#undef PRINT_COUNTER
diff a/src/hotspot/share/prims/jvmtiEnv.cpp b/src/hotspot/share/prims/jvmtiEnv.cpp
--- a/src/hotspot/share/prims/jvmtiEnv.cpp
+++ b/src/hotspot/share/prims/jvmtiEnv.cpp
@@ -666,11 +666,11 @@
     // The phase is checked by the wrapper that called this function,
     // but this thread could be racing with the thread that is
     // terminating the VM so we check one more time.
 
     // create the zip entry
-    ClassPathZipEntry* zip_entry = ClassLoader::create_class_path_zip_entry(segment, true);
+    ClassPathZipEntry* zip_entry = ClassLoader::create_class_path_zip_entry(segment);
     if (zip_entry == nullptr) {
       return JVMTI_ERROR_ILLEGAL_ARGUMENT;
     }
 
     // add the jar file to the bootclasspath
@@ -708,11 +708,11 @@
     JavaThread* THREAD = JavaThread::current(); // For exception macros.
     HandleMark hm(THREAD);
 
     // create the zip entry (which will open the zip file and hence
     // check that the segment is indeed a zip file).
-    ClassPathZipEntry* zip_entry = ClassLoader::create_class_path_zip_entry(segment, false);
+    ClassPathZipEntry* zip_entry = ClassLoader::create_class_path_zip_entry(segment);
     if (zip_entry == nullptr) {
       return JVMTI_ERROR_ILLEGAL_ARGUMENT;
     }
     delete zip_entry;   // no longer needed
 
diff a/src/hotspot/share/prims/methodHandles.cpp b/src/hotspot/share/prims/methodHandles.cpp
--- a/src/hotspot/share/prims/methodHandles.cpp
+++ b/src/hotspot/share/prims/methodHandles.cpp
@@ -21,14 +21,16 @@
  * questions.
  *
  */
 
 #include "precompiled.hpp"
+#include "cds/cds_globals.hpp"
 #include "classfile/javaClasses.inline.hpp"
 #include "classfile/stringTable.hpp"
 #include "classfile/symbolTable.hpp"
 #include "classfile/systemDictionary.hpp"
+#include "classfile/systemDictionaryShared.hpp"
 #include "classfile/vmClasses.hpp"
 #include "code/codeCache.hpp"
 #include "code/dependencyContext.hpp"
 #include "compiler/compileBroker.hpp"
 #include "interpreter/interpreter.hpp"
@@ -49,18 +51,21 @@
 #include "prims/methodHandles.hpp"
 #include "runtime/deoptimization.hpp"
 #include "runtime/fieldDescriptor.inline.hpp"
 #include "runtime/handles.inline.hpp"
 #include "runtime/interfaceSupport.inline.hpp"
+#include "runtime/java.hpp"
 #include "runtime/javaCalls.hpp"
 #include "runtime/jniHandles.inline.hpp"
+#include "runtime/perfData.inline.hpp"
 #include "runtime/timerTrace.hpp"
 #include "runtime/reflection.hpp"
 #include "runtime/safepointVerifiers.hpp"
 #include "runtime/signature.hpp"
 #include "runtime/stubRoutines.hpp"
 #include "sanitizers/leak.hpp"
+#include "services/management.hpp"
 #include "utilities/exceptions.hpp"
 
 
 /*
  * JSR 292 reference implementation: method handles
@@ -1042,11 +1047,11 @@
 #undef VALUE_COMMA
 #undef STRING_NULL
 #undef EACH_NAMED_CON
 #endif // PRODUCT
 
-JVM_ENTRY(jint, MHN_getNamedCon(JNIEnv *env, jobject igcls, jint which, jobjectArray box_jh)) {
+JVM_ENTRY_PROF(jint, MHN_getNamedCon, MHN_getNamedCon(JNIEnv *env, jobject igcls, jint which, jobjectArray box_jh)) {
 #ifndef PRODUCT
   if (advertise_con_value(which)) {
     assert(which >= 0 && which < con_value_count, "");
     int con = con_values[which];
     objArrayHandle box(THREAD, (objArrayOop) JNIHandles::resolve(box_jh));
@@ -1063,29 +1068,29 @@
   return 0;
 }
 JVM_END
 
 // void init(MemberName self, AccessibleObject ref)
-JVM_ENTRY(void, MHN_init_Mem(JNIEnv *env, jobject igcls, jobject mname_jh, jobject target_jh)) {
+JVM_ENTRY_PROF(void, MHN_init_Mem, MHN_init_Mem(JNIEnv *env, jobject igcls, jobject mname_jh, jobject target_jh)) {
   if (mname_jh == nullptr) { THROW_MSG(vmSymbols::java_lang_InternalError(), "mname is null"); }
   if (target_jh == nullptr) { THROW_MSG(vmSymbols::java_lang_InternalError(), "target is null"); }
   Handle mname(THREAD, JNIHandles::resolve_non_null(mname_jh));
   Handle target(THREAD, JNIHandles::resolve_non_null(target_jh));
   MethodHandles::init_MemberName(mname, target, CHECK);
 }
 JVM_END
 
 // void expand(MemberName self)
-JVM_ENTRY(void, MHN_expand_Mem(JNIEnv *env, jobject igcls, jobject mname_jh)) {
+JVM_ENTRY_PROF(void, MHN_expand_Mem, MHN_expand_Mem(JNIEnv *env, jobject igcls, jobject mname_jh)) {
   if (mname_jh == nullptr) { THROW_MSG(vmSymbols::java_lang_InternalError(), "mname is null"); }
   Handle mname(THREAD, JNIHandles::resolve_non_null(mname_jh));
   MethodHandles::expand_MemberName(mname, 0, CHECK);
 }
 JVM_END
 
 // void resolve(MemberName self, Class<?> caller)
-JVM_ENTRY(jobject, MHN_resolve_Mem(JNIEnv *env, jobject igcls, jobject mname_jh, jclass caller_jh,
+JVM_ENTRY_PROF(jobject, MHN_resolve_Mem, MHN_resolve_Mem(JNIEnv *env, jobject igcls, jobject mname_jh, jclass caller_jh,
     jint lookup_mode, jboolean speculative_resolve)) {
   if (mname_jh == nullptr) { THROW_MSG_NULL(vmSymbols::java_lang_InternalError(), "mname is null"); }
   Handle mname(THREAD, JNIHandles::resolve_non_null(mname_jh));
 
   // The trusted Java code that calls this method should already have performed
@@ -1167,29 +1172,29 @@
   const char* msg = (must_be_static ? "static field required" : "non-static field required");
   THROW_MSG_0(vmSymbols::java_lang_InternalError(), msg);
   return 0;
 }
 
-JVM_ENTRY(jlong, MHN_objectFieldOffset(JNIEnv *env, jobject igcls, jobject mname_jh)) {
+JVM_ENTRY_PROF(jlong, MHN_objectFieldOffset, MHN_objectFieldOffset(JNIEnv *env, jobject igcls, jobject mname_jh)) {
   return find_member_field_offset(JNIHandles::resolve(mname_jh), false, THREAD);
 }
 JVM_END
 
-JVM_ENTRY(jlong, MHN_staticFieldOffset(JNIEnv *env, jobject igcls, jobject mname_jh)) {
+JVM_ENTRY_PROF(jlong, MHN_staticFieldOffset, MHN_staticFieldOffset(JNIEnv *env, jobject igcls, jobject mname_jh)) {
   return find_member_field_offset(JNIHandles::resolve(mname_jh), true, THREAD);
 }
 JVM_END
 
-JVM_ENTRY(jobject, MHN_staticFieldBase(JNIEnv *env, jobject igcls, jobject mname_jh)) {
+JVM_ENTRY_PROF(jobject, MHN_staticFieldBase, MHN_staticFieldBase(JNIEnv *env, jobject igcls, jobject mname_jh)) {
   // use the other function to perform sanity checks:
   jlong ignore = find_member_field_offset(JNIHandles::resolve(mname_jh), true, CHECK_NULL);
   oop clazz = java_lang_invoke_MemberName::clazz(JNIHandles::resolve_non_null(mname_jh));
   return JNIHandles::make_local(THREAD, clazz);
 }
 JVM_END
 
-JVM_ENTRY(jobject, MHN_getMemberVMInfo(JNIEnv *env, jobject igcls, jobject mname_jh)) {
+JVM_ENTRY_PROF(jobject, MHN_getMemberVMInfo, MHN_getMemberVMInfo(JNIEnv *env, jobject igcls, jobject mname_jh)) {
   if (mname_jh == nullptr)  return nullptr;
   Handle mname(THREAD, JNIHandles::resolve_non_null(mname_jh));
   intptr_t vmindex  = java_lang_invoke_MemberName::vmindex(mname());
   objArrayHandle result = oopFactory::new_objArray_handle(vmClasses::Object_klass(), 2, CHECK_NULL);
   jvalue vmindex_value; vmindex_value.j = (long)vmindex;
@@ -1207,11 +1212,11 @@
   result->obj_at_put(1, x);
   return JNIHandles::make_local(THREAD, result());
 }
 JVM_END
 
-JVM_ENTRY(void, MHN_setCallSiteTargetNormal(JNIEnv* env, jobject igcls, jobject call_site_jh, jobject target_jh)) {
+JVM_ENTRY_PROF(void, MHN_setCallSiteTargetNormal, MHN_setCallSiteTargetNormal(JNIEnv* env, jobject igcls, jobject call_site_jh, jobject target_jh)) {
   Handle call_site(THREAD, JNIHandles::resolve_non_null(call_site_jh));
   Handle target   (THREAD, JNIHandles::resolve_non_null(target_jh));
   DeoptimizationScope deopt_scope;
   {
     // Walk all nmethods depending on this call site.
@@ -1223,11 +1228,43 @@
     deopt_scope.deoptimize_marked();
   }
 }
 JVM_END
 
-JVM_ENTRY(void, MHN_setCallSiteTargetVolatile(JNIEnv* env, jobject igcls, jobject call_site_jh, jobject target_jh)) {
+// Make sure the class is linked. If the class cannot be verified, etc, an exception will be thrown.
+JVM_ENTRY_PROF(void, MHN_checkArchivable, MHN_checkArchivable(JNIEnv *env, jobject igcls, jclass klass_jh)) {
+  if (klass_jh == nullptr) { THROW_MSG(vmSymbols::java_lang_InternalError(), "klass is null"); }
+
+  if (CDSConfig::is_dumping_invokedynamic()) {
+    Klass* klass = java_lang_Class::as_Klass(JNIHandles::resolve_non_null(klass_jh));
+    if (klass != nullptr && klass->is_instance_klass()) {
+      // klass could be null during very early VM start-up
+      InstanceKlass* ik = InstanceKlass::cast(klass);
+      ik->link_class(THREAD); // exception will be thrown if unverifiable
+      if (!ik->is_linked()) {
+        assert(HAS_PENDING_EXCEPTION, "must be");
+        ResourceMark rm;
+        log_warning(cds)("Cannot use unverifiable class %s in MethodType",
+                         klass->external_name());
+        return;
+      }
+
+      if (SystemDictionaryShared::is_jfr_event_class(ik)) {
+        ResourceMark rm;
+        log_warning(cds)("Cannot use JFR event class %s in MethodType",
+                         klass->external_name());
+        Exceptions::fthrow(THREAD_AND_LOCATION,
+                           vmSymbols::java_lang_NoClassDefFoundError(),
+                           "Class %s, or one of its supertypes, is a JFR event class",
+                           klass->external_name());
+      }
+    }
+  }
+}
+JVM_END
+
+JVM_ENTRY_PROF(void, MHN_setCallSiteTargetVolatile, MHN_setCallSiteTargetVolatile(JNIEnv* env, jobject igcls, jobject call_site_jh, jobject target_jh)) {
   Handle call_site(THREAD, JNIHandles::resolve_non_null(call_site_jh));
   Handle target   (THREAD, JNIHandles::resolve_non_null(target_jh));
   DeoptimizationScope deopt_scope;
   {
     // Walk all nmethods depending on this call site.
@@ -1239,11 +1276,11 @@
     deopt_scope.deoptimize_marked();
   }
 }
 JVM_END
 
-JVM_ENTRY(void, MHN_copyOutBootstrapArguments(JNIEnv* env, jobject igcls,
+JVM_ENTRY_PROF(void, MHN_copyOutBootstrapArguments, MHN_copyOutBootstrapArguments(JNIEnv* env, jobject igcls,
                                               jobject caller_jh, jintArray index_info_jh,
                                               jint start, jint end,
                                               jobjectArray buf_jh, jint pos,
                                               jboolean resolve, jobject ifna_jh)) {
   Klass* caller_k = java_lang_Class::as_Klass(JNIHandles::resolve(caller_jh));
@@ -1322,11 +1359,11 @@
 }
 JVM_END
 
 // It is called by a Cleaner object which ensures that dropped CallSites properly
 // deallocate their dependency information.
-JVM_ENTRY(void, MHN_clearCallSiteContext(JNIEnv* env, jobject igcls, jobject context_jh)) {
+JVM_ENTRY_PROF(void, MHN_clearCallSiteContext, MHN_clearCallSiteContext(JNIEnv* env, jobject igcls, jobject context_jh)) {
   Handle context(THREAD, JNIHandles::resolve_non_null(context_jh));
   DeoptimizationScope deopt_scope;
   {
     NoSafepointVerifier nsv;
     MutexLocker ml(THREAD, CodeCache_lock, Mutex::_no_safepoint_check_flag);
@@ -1342,22 +1379,22 @@
 /**
  * Throws a java/lang/UnsupportedOperationException unconditionally.
  * This is required by the specification of MethodHandle.invoke if
  * invoked directly.
  */
-JVM_ENTRY(jobject, MH_invoke_UOE(JNIEnv* env, jobject mh, jobjectArray args)) {
+JVM_ENTRY_PROF(jobject, MH_invoke_UOE, MH_invoke_UOE(JNIEnv* env, jobject mh, jobjectArray args)) {
   THROW_MSG_NULL(vmSymbols::java_lang_UnsupportedOperationException(), "MethodHandle.invoke cannot be invoked reflectively");
   return nullptr;
 }
 JVM_END
 
 /**
  * Throws a java/lang/UnsupportedOperationException unconditionally.
  * This is required by the specification of MethodHandle.invokeExact if
  * invoked directly.
  */
-JVM_ENTRY(jobject, MH_invokeExact_UOE(JNIEnv* env, jobject mh, jobjectArray args)) {
+JVM_ENTRY_PROF(jobject, MH_invokeExact_UOE, MH_invokeExact_UOE(JNIEnv* env, jobject mh, jobjectArray args)) {
   THROW_MSG_NULL(vmSymbols::java_lang_UnsupportedOperationException(), "MethodHandle.invokeExact cannot be invoked reflectively");
   return nullptr;
 }
 JVM_END
 
@@ -1448,11 +1485,11 @@
 };
 
 /**
  * This one function is exported, used by NativeLookup.
  */
-JVM_ENTRY(void, JVM_RegisterMethodHandleMethods(JNIEnv *env, jclass MHN_class)) {
+JVM_ENTRY_PROF(void, JVM_RegisterMethodHandleMethods, JVM_RegisterMethodHandleMethods(JNIEnv *env, jclass MHN_class)) {
   assert(!MethodHandles::enabled(), "must not be enabled");
   assert(vmClasses::MethodHandle_klass() != nullptr, "should be present");
   assert(vmClasses::VarHandle_klass() != nullptr, "should be present");
 
   oop mh_mirror = vmClasses::MethodHandle_klass()->java_mirror();
@@ -1479,5 +1516,60 @@
   log_debug(methodhandles, indy)("MethodHandle support loaded (using LambdaForms)");
 
   MethodHandles::set_enabled(true);
 }
 JVM_END
+
+#define DO_COUNTERS(macro)             \
+  macro(MHN_init_Mem)                  \
+  macro(MHN_expand_Mem)                \
+  macro(MHN_resolve_Mem)               \
+  macro(MHN_checkArchivable)           \
+  macro(MHN_getNamedCon)               \
+  macro(MHN_objectFieldOffset)         \
+  macro(MHN_setCallSiteTargetNormal)   \
+  macro(MHN_setCallSiteTargetVolatile) \
+  macro(MHN_copyOutBootstrapArguments) \
+  macro(MHN_clearCallSiteContext)      \
+  macro(MHN_staticFieldOffset)         \
+  macro(MHN_staticFieldBase)           \
+  macro(MHN_getMemberVMInfo)           \
+  macro(MH_invoke_UOE)                 \
+  macro(MH_invokeExact_UOE)            \
+  macro(JVM_RegisterMethodHandleMethods)
+
+#define INIT_COUNTER(name) \
+    NEWPERFTICKCOUNTERS(_perf_##name##_timer, SUN_RT, #name); \
+    NEWPERFEVENTCOUNTER(_perf_##name##_count, SUN_RT, #name "_count"); \
+
+void MethodHandles::init_counters() {
+  if (UsePerfData) {
+    EXCEPTION_MARK;
+
+    DO_COUNTERS(INIT_COUNTER)
+
+    if (HAS_PENDING_EXCEPTION) {
+      vm_exit_during_initialization("perf_mhn_init failed unexpectedly");
+    }
+  }
+}
+
+#undef INIT_COUNTER
+
+#define PRINT_COUNTER(name) {\
+  jlong count = _perf_##name##_count->get_value(); \
+  if (count > 0) { \
+    st->print_cr("  %-40s = " JLONG_FORMAT_W(6) "us (elapsed) " JLONG_FORMAT_W(6) "us (thread) (" JLONG_FORMAT_W(5) " events)", #name, \
+                 _perf_##name##_timer->elapsed_counter_value_us(), \
+                 _perf_##name##_timer->thread_counter_value_us(), \
+                 count); \
+  }}
+
+void MethodHandles::print_counters_on(outputStream* st) {
+  if (ProfileVMCalls && UsePerfData) {
+    DO_COUNTERS(PRINT_COUNTER)
+  } else {
+    st->print_cr("  MHN:  no info (%s is disabled)", (UsePerfData ? "ProfileVMCalls" : "UsePerfData"));
+  }
+}
+
+#undef PRINT_COUNTER
diff a/src/hotspot/share/prims/methodHandles.hpp b/src/hotspot/share/prims/methodHandles.hpp
--- a/src/hotspot/share/prims/methodHandles.hpp
+++ b/src/hotspot/share/prims/methodHandles.hpp
@@ -185,10 +185,14 @@
 #include CPU_HEADER(methodHandles)
 
   // Tracing
   static void trace_method_handle(MacroAssembler* _masm, const char* adaptername) PRODUCT_RETURN;
   static void trace_method_handle_interpreter_entry(MacroAssembler* _masm, vmIntrinsics::ID iid);
+
+public:
+  static void init_counters();
+  static void print_counters_on(outputStream* st);
 };
 
 //------------------------------------------------------------------------------
 // MethodHandlesAdapterGenerator
 //
diff a/src/hotspot/share/prims/perf.cpp b/src/hotspot/share/prims/perf.cpp
--- a/src/hotspot/share/prims/perf.cpp
+++ b/src/hotspot/share/prims/perf.cpp
@@ -35,16 +35,10 @@
 
 /*
  *      Implementation of class jdk.internal.perf.Perf
  */
 
-
-#define PERF_ENTRY(result_type, header) \
-  JVM_ENTRY(result_type, header)
-
-#define PERF_END JVM_END
-
 #define PerfWrapper(arg) /* Unimplemented at this time */
 
 static char* jstr_to_utf(JNIEnv *env, jstring str, TRAPS) {
 
   char* utfstr = nullptr;
@@ -62,11 +56,11 @@
   env->GetStringUTFRegion(str, 0, unicode_len, utfstr);
 
   return utfstr;
 }
 
-PERF_ENTRY(jobject, Perf_Attach(JNIEnv *env, jobject unused, int vmid))
+JVM_ENTRY(jobject, Perf_Attach(JNIEnv *env, jobject unused, int vmid))
 
   PerfWrapper("Perf_Attach");
 
   char* address = nullptr;
   size_t capacity = 0;
@@ -77,13 +71,13 @@
   {
     ThreadToNativeFromVM ttnfv(thread);
     return env->NewDirectByteBuffer(address, (jlong)capacity);
   }
 
-PERF_END
+JVM_END
 
-PERF_ENTRY(void, Perf_Detach(JNIEnv *env, jobject unused, jobject buffer))
+JVM_ENTRY(void, Perf_Detach(JNIEnv *env, jobject unused, jobject buffer))
 
   PerfWrapper("Perf_Detach");
 
   if (!UsePerfData) {
     // With -XX:-UsePerfData, detach is just a NOP
@@ -100,13 +94,13 @@
    capacity = env->GetDirectBufferCapacity(buffer);
   }
 
   PerfMemory::detach((char*)address, capacity);
 
-PERF_END
+JVM_END
 
-PERF_ENTRY(jobject, Perf_CreateLong(JNIEnv *env, jobject perf, jstring name,
+JVM_ENTRY(jobject, Perf_CreateLong(JNIEnv *env, jobject perf, jstring name,
            int variability, int units, jlong value))
 
   PerfWrapper("Perf_CreateLong");
 
   char* name_utf = nullptr;
@@ -161,13 +155,13 @@
   {
     ThreadToNativeFromVM ttnfv(thread);
     return env->NewDirectByteBuffer(lp, sizeof(jlong));
   }
 
-PERF_END
+JVM_END
 
-PERF_ENTRY(jobject, Perf_CreateByteArray(JNIEnv *env, jobject perf,
+JVM_ENTRY(jobject, Perf_CreateByteArray(JNIEnv *env, jobject perf,
                                          jstring name, jint variability,
                                          jint units, jbyteArray value,
                                          jint maxlength))
 
   PerfWrapper("Perf_CreateByteArray");
@@ -244,37 +238,37 @@
   {
     ThreadToNativeFromVM ttnfv(thread);
     return env->NewDirectByteBuffer(cp, maxlength+1);
   }
 
-PERF_END
+JVM_END
 
-PERF_ENTRY(jlong, Perf_HighResCounter(JNIEnv *env, jobject perf))
+JVM_ENTRY(jlong, Perf_HighResCounter(JNIEnv *env, jobject perf))
 
   PerfWrapper("Perf_HighResCounter");
 
   // this should be a method in java.lang.System. This value could
   // be acquired through access to a PerfData performance counter, but
   // doing so would require that the PerfData monitoring overhead be
   // incurred by all Java applications, which is unacceptable.
 
   return os::elapsed_counter();
 
-PERF_END
+JVM_END
 
-PERF_ENTRY(jlong, Perf_HighResFrequency(JNIEnv *env, jobject perf))
+JVM_ENTRY(jlong, Perf_HighResFrequency(JNIEnv *env, jobject perf))
 
   PerfWrapper("Perf_HighResFrequency");
 
   // this should be a method in java.lang.System. This value could
   // be acquired through access to a PerfData performance counter, but
   // doing so would require that the PerfData monitoring overhead be
   // incurred by all Java applications, which is unacceptable.
 
   return os::elapsed_frequency();
 
-PERF_END
+JVM_END
 
 /// JVM_RegisterPerfMethods
 
 #define CC (char*)  /*cast a literal from (const char*)*/
 #define FN_PTR(f) CAST_FROM_FN_PTR(void*, &f)
diff a/src/hotspot/share/prims/unsafe.cpp b/src/hotspot/share/prims/unsafe.cpp
--- a/src/hotspot/share/prims/unsafe.cpp
+++ b/src/hotspot/share/prims/unsafe.cpp
@@ -352,11 +352,11 @@
 
 ////// Allocation requests
 
 UNSAFE_ENTRY(jobject, Unsafe_AllocateInstance(JNIEnv *env, jobject unsafe, jclass cls)) {
   JvmtiVMObjectAllocEventCollector oam;
-  instanceOop i = InstanceKlass::allocate_instance(JNIHandles::resolve_non_null(cls), CHECK_NULL);
+  instanceOop i = InstanceKlass::allocate_instance(JNIHandles::resolve_non_null(cls), "unsafe", CHECK_NULL);
   return JNIHandles::make_local(THREAD, i);
 } UNSAFE_END
 
 UNSAFE_LEAF(jlong, Unsafe_AllocateMemory0(JNIEnv *env, jobject unsafe, jlong size)) {
   size_t sz = (size_t)size;
diff a/src/hotspot/share/prims/whitebox.cpp b/src/hotspot/share/prims/whitebox.cpp
--- a/src/hotspot/share/prims/whitebox.cpp
+++ b/src/hotspot/share/prims/whitebox.cpp
@@ -1098,11 +1098,11 @@
   DirectiveSet* directive = DirectivesStack::getMatchingDirective(mh, comp);
   bool is_blocking = !directive->BackgroundCompilationOption;
   DirectivesStack::release(directive);
 
   // Compile method and check result
-  nmethod* nm = CompileBroker::compile_method(mh, bci, comp_level, mh, mh->invocation_count(), CompileTask::Reason_Whitebox, CHECK_false);
+  nmethod* nm = CompileBroker::compile_method(mh, bci, comp_level, mh, mh->invocation_count(), false, CompileTask::Reason_Whitebox, CHECK_false);
   MutexLocker mu(THREAD, Compile_lock);
   bool is_queued = mh->queued_for_compilation();
   if ((!is_blocking && is_queued) || nm != nullptr) {
     return true;
   }
